# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as 
# published by the Free Software Foundation here:
# (http://www.gnu.org/licenses/gpl-2.0.html)
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

DEPENDS =
ARCH = x86_64
URL = http://www.vim.org/
DESC = Vim is an advanced text editor that seeks to provide the power of \
the de-facto Unix editor 'Vi', with a more complete feature set.
SNAPVER = sr0

ARCHIVE := $(PWD)/SRC/$(shell ls SRC|egrep '(bz2|gz|tar|xz)$$'|tail -1)
TYPE := $(shell file -ib $(ARCHIVE)|cut -d';' -f1|tr -d '\n')
SRCDIR := $(shell tar -tf $(ARCHIVE)|head -1|sed 's/\/.*//')
PATCHDIR := $(PWD)/SRC/patches
VERSION := $(shell echo $(ARCHIVE)|sed 's/\.tar.*//'| \
	egrep -o '\-[0-9].*'|sed 's/^-//')$(SNAPVER)

MAKE = make
MAKEINST = make install
SNAPHACKS = ln -sv vim $(ROOT)/usr/bin/vi

include /usr/share/snap/Makefile.snaplinux

$(SRCDIR)/configure: $(ARCHIVE)
	@if [ '$(TYPE)' == 'application/x-bzip2' ]; then \
		tar -jxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-gzip' ]; then \
		tar -zxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-tar' ]; then \
		tar -xf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-xz' ]; then \
		tar -xf $(ARCHIVE); \
	else \
		echo 'Unable to determine archive type'; \
		exit 1; \
	fi
	@touch $(SRCDIR)/configure

$(SRCDIR)/src/auto/config.log: $(SRCDIR)/configure
	@if [ -f $(PATCHDIR)/*.patch ]; then \
		cd $(SRCDIR) && cat $(PATCHDIR)/*.patch|patch --verbose -Np1; \
	fi
	@cd $(SRCDIR); \
	./configure \
		--prefix=/usr \
		--docdir=/usr/share/doc \
		--build=x86_64-snap-linux-gnu \
		--host=x86_64-snap-linux-gnu \
		--target=x86_64-snap-linux-gnu

$(SRCDIR)/src/vim: $(SRCDIR)/src/auto/config.log
	@cd $(SRCDIR); \
	$(MAKE)

$(ROOT): $(SRCDIR)/src/vim
	@if [ -d $(ROOT) ]; then \
		touch $(ROOT); \
	else \
		mkdir -v $(ROOT); \
	fi

	@cd $(SRCDIR); \
	$(MAKEINST) DESTDIR=$(ROOT)

	@$(SNAPHACKS)

test: $(ROOT)
	@cd $(SRCDIR); \
	make -j1 test

clean:
	@rm -rvf $(ROOT) \
		$(SNAPINFO) \
		$(MANIFEST) \
		$(FILES) \
		$(SRCDIR)

